; L O C K - 8 2 
;	v4.2 for CrASHv1.6 - TI-82 Assembly Shell
;		last updated 4-14-2000
;	By	Jon Johnson
;
;-----------------------
;Not much can be done to improve this nearly perfect password program
;it's not commented much, but the code is still here for your learning
;probably could use some optimizing but that's ok, still 
;---------------------
#INCLUDE "Crash82.inc"
.db "Lock-82 v4.2",0
flag      = TEXT_MEM
lock
	call lockedoutput
;---------------------
;	CALL $07EA	;old power down method
;new powerdown method 
;this should let you change battery while calc is locked!
;
;props to Sam Heald for this power off code
;
;---------------------
 DI                  ; disable interrupts
 LD  A, 01           ; bit 3 = lcd status
 OUT ($03), A        ; bit 0 = ON-interrupt status
 EI                  ; enable interrupts
 HALT                ; wait for ON (that's the only interrupt)
 RES 4, (IY $09)     ; Turn off 'ON' flag
;---------------------
	;end of power off code thanks Sam!
     	LD HL,login
     	ROM_CALL(D_ZT_STR)
	CALL check
	ld	a,(flag)
	cp	0
        JP NZ,(lock)
        JP Z,(mainstarter)

mainstarter:
	ROM_CALL(CLEARLCD)
	LD HL,MenuData_Main
	call Menu
	cp 2
	jr z, newpass
	cp $FF
	ret z
	cp $FE
	ret z
	cp 1
	jr z, lock
	cp 3
	jr z, ChangeYourName
	cp 4
	jr z, AboutMenu
	cp 5
	ret z
	jr mainstarter
AboutMenu:
	ld hl,MenuData_About
	call Menu
	jr mainstarter
ChangeYourName:
	call lockedoutput
	ld hl,CNText
	ROM_CALL(D_ZT_STR)
	ld hl,regtop
	ld a,15
	ld bc,$0002
	call EditString
	jr mainstarter
newpass:
	call lockedoutput
     	LD HL,newspass
     	ROM_CALL(D_ZT_STR)
	ld	hl,password
newloop:
	halt
	push	hl
	CALL GET_KEY
	pop	hl
	cp	0
	jr	z,newloop
	ld	(hl),a
	CP	9
	jr	z,endnew
	push	hl
     	LD HL,star
     	ROM_CALL(D_ZT_STR)
	ld	bc,1
	pop	hl
	add	HL,bc
	ld	a,(hl)
	CP	255
	jr	nz,newloop
endnew:
	jp mainstarter
check:
	ld	a,0
	ld	(flag),a
	ld	hl,password
checkloop:
	halt
	push	hl
	CALL GET_KEY
	pop	hl
	cp	0
	jr	z,checkloop
	ld	b,(hl)
	cp	b
	jr	z,noflag
	ld	d,a
	ld	a,1
	ld	(flag),a
	ld	a,d
noflag:
	CP	9
	jr	z,endpass
	push	hl
     	LD HL,star
     	ROM_CALL(D_ZT_STR)
	ld	bc,1
	pop	hl
	add	HL,bc
	ld	a,(hl)
	CP	255
	jr	nz,checkloop
endpass:
	ret
lockedoutput:
	ROM_CALL(CLEARLCD)
	sub	a
	ld	($800c),a
	ld	($800d),a
	set	3,(IY+05)
     	LD HL,title
     	ROM_CALL(D_ZT_STR)
	ld	HL,$0006
	ld	($800c),hl
     	LD HL,regto
     	ROM_CALL(D_ZT_STR)
	res	3,(IY+05)
	ld	HL,$0007
	ld	($800c),hl
     	LD HL,regtop
     	ROM_CALL(D_ZT_STR)
     	ld	HL,$0001
	ld	($800c),hl
	ret

newspass:
        .db     "New Code:",0
login:
        .db	"The Code:",0
star:
	.db	"*",0
password:
	.db	9,9,9,9,9,9,9,9,255,0


.include "CCHAR.ASM"
.include "MENUROUT.ASM"

MenuData_Main:
.db 8
title: .db $E1," Lock-82 v4.2 ",$E1,0
.db "Lock Ti-82",0
.db "Change Pass",0
CNText:.db "Change Name",0
.db "About Lock-82",0
.db "Exit Lock-82",0
.db 0
regto:.db "  Property of:  ",0
regtop:.db "               ",0

MenuData_About:
.db 4
;    1   23456789012345  6
.db $E1,$E1,$E1,$E1," About! ",$E1,$E1,$E1,$E1,0
.db "Programmed by: ",0
.db "Jon Johnson",0
.db "http://tawp.netfirms.com",0
.db "(c)1998-2000",0
.end